package com.ekingwin.bas.cloud.document.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.ekingwin.bas.cloud.document.dao.DocumentImageDao;
import com.ekingwin.bas.cloud.document.dao.entity.DocumentImage;
import com.ekingwin.bas.cloud.document.dto.DocumentImageDto;
import com.ekingwin.bas.cloud.document.service.IDocumentImageService;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.BaseService;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;

@Primary
@Service
public class DocumentImageServiceImpl extends BaseService implements IDocumentImageService{
	@Autowired
	private DocumentImageDao documentImageDao;

	@Override
	public boolean save(DocumentImageDto documentImageDto) throws BasException {
		try {
			save(documentImageDto,DocumentImage.class,documentImageDao);
		} catch (Exception e) {
			log.error(e.getMessage(), e);
		
		}
		return true;
	}

	@Override
	public boolean delete(String id) throws BasException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public PageCriteria<DocumentImageDto> query(QueryDTO query)
			throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public DocumentImageDto get(String id) throws BasException {
		try {
			DocumentImage documentImage = documentImageDao.getByID(id);
			DocumentImageDto documentImageDto = new DocumentImageDto();
			super.commonBuild(documentImageDto, documentImage);
			return documentImageDto;
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw  new BasException();
		}
	}
	@Override
	public List<DocumentImageDto> getChildimage(String pid) throws BasException {
		try {
			List<DocumentImage> childimageList = documentImageDao.getChildimage(pid);
			List<DocumentImageDto> result = new ArrayList<DocumentImageDto>();
			for(int i = 0 ; i < childimageList.size() ; i++  ){
				DocumentImage documentImage = childimageList.get(i);
				DocumentImageDto documentImageDto = new DocumentImageDto();
				super.commonBuild(documentImageDto, documentImage);
				result.add(documentImageDto);
			}
			return result;
		} catch (Exception e) {
			log.error(e.getMessage(), e);
			throw  new BasException();
		}
	}
}
