package com.ekingwin.bas.cloud.file.web;

import com.ekingwin.bas.cloud.file.service.FileDocumentService;
import com.ekingwin.bas.cloud.file.vo.IpDocumentVo;
import com.ekingwin.bas.cloud.util.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * @program: rcworkspace
 * @description: 文件上传
 * @author: zhangjie
 * @create: 2020-02-12
 **/
@RestController
@RequestMapping(value = "/fileDocument/")
@Api(tags = "文件上传", description = "文件上传", value = "文件上传")
public class FileDocumentController {


    @Autowired
    private FileDocumentService fileDocumentService;

    @RequestMapping("/uploads")
    @ResponseBody
    @ApiOperation(value = "附件上传", notes = "附件上传")
    public Result fileUpload(HttpServletRequest request) throws Exception {

        List<MultipartFile> files =((MultipartHttpServletRequest)request).getFiles("file");
        List<IpDocumentVo> results=new ArrayList<>();
        if (files !=null && files.size()>0){
            results=fileDocumentService.uploadFiles(files);
        }
        return  Result.ok(results);
    }
}
