package com.ekingwin.bas.cloud.rabbit.receiver;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ekingwin.bas.cloud.supplier.dto.SuppliersDto;
import com.ekingwin.bas.cloud.supplier.service.ISupplierService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.core.ExchangeTypes;
import org.springframework.amqp.rabbit.annotation.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @ClassName :
 * @description:
 * @author: zhangjie
 * @create: 2019-10-24 20:23
 **/
@Component
@RabbitListener(bindings = @QueueBinding(
        value = @Queue(value = "${rabbitmq.receiver.suppliers}", autoDelete = "true"),
        exchange = @Exchange(value = "${rabbitmq.exchange.suppliers}", type = ExchangeTypes.TOPIC),
        key = "*.suppliers.info"
))
public class SupplierReceiver {

    private Logger logger = LoggerFactory.getLogger(SupplierReceiver.class);

    @Autowired
    private ISupplierService supplierService;

    @RabbitHandler
    public void saveSuppliers(String msg) throws Exception {

        try {
            logger.info("供应商数据：》》》》》》》》》"+msg);
            com.alibaba.fastjson.JSONObject jsonObject = JSONObject.parseObject(msg);
            SuppliersDto codeTypeDto = JSON.toJavaObject(jsonObject,SuppliersDto.class);
            supplierService.saveOrUpdateSuppliers(codeTypeDto);

        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
    }
}
