package com.ekingwin.bas.cloud.rolejcy.service.impl;


import com.ekingwin.bas.cloud.rolejcy.dao.RoleegoDao;
import com.ekingwin.bas.cloud.rolejcy.dto.IRoleegoPageDto;
import com.ekingwin.bas.cloud.rolejcy.service.IRoleegoService;
import com.ekingwin.bas.cloud.rolejcy.vo.RoleInfoVo;
import com.ekingwin.bas.cloud.user.dao.entity.User;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

@Primary
@Service
@Transactional(rollbackFor = Exception.class)
public class RoleegoServiceImpl implements IRoleegoService {

	@Autowired
	private RoleegoDao roleegoDao;

	@Override
	public PageInfo<RoleInfoVo> selectRolePage(IRoleegoPageDto iRoleegoPageDto) throws Exception {
		PageHelper.startPage(iRoleegoPageDto.getPagenum(), iRoleegoPageDto.getPagesize());
		List<RoleInfoVo> infoVoList = roleegoDao.selectRolePage(iRoleegoPageDto);
		PageInfo<RoleInfoVo> pageInfo = new PageInfo<>(infoVoList);
		return pageInfo;
	}

	@Override
	public PageInfo<RoleInfoVo> selectAllUserPage(IRoleegoPageDto iRoleegoPageDto) throws Exception {
		PageHelper.startPage(iRoleegoPageDto.getPagenum(), iRoleegoPageDto.getPagesize());
		List<RoleInfoVo> infoVoList = roleegoDao.selectAllUserPage(iRoleegoPageDto);
		PageInfo<RoleInfoVo> pageInfo = new PageInfo<>(infoVoList);
		return pageInfo;
	}

	@Override
	public void insertAuthRole(String userId, String roleId) throws Exception {
		HashMap paramMap = new HashMap();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		paramMap.put("userid",userId);
		paramMap.put("roleid",roleId);
		paramMap.put("createon",formatter.format(new Date()));
		roleegoDao.insertAuthRole(paramMap);
	}
}
