package com.ekingwin.bas.cloud.tenant.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.ekingwin.bas.cloud.infra.dto.BaseResult;
import com.ekingwin.bas.cloud.infra.dto.QueryDTO;
import com.ekingwin.bas.cloud.infra.exception.BasException;
import com.ekingwin.bas.cloud.infra.service.BaseService;
import com.ekingwin.bas.cloud.infra.utils.db.PageCriteria;
import com.ekingwin.bas.cloud.tenant.dao.TenantDao;
import com.ekingwin.bas.cloud.tenant.dao.TenantEmployeeDao;
import com.ekingwin.bas.cloud.tenant.dao.entity.TenantEmployee;
import com.ekingwin.bas.cloud.tenant.dto.TenantEmployeeDto;
import com.ekingwin.bas.cloud.tenant.service.ITenantEmployeeService;

@Primary
@Service
public class TenantEmployeeServiceImpl extends BaseService implements ITenantEmployeeService {
	@Autowired
	private TenantEmployeeDao dao;
	
	@Autowired
	private TenantDao tenantDao;

	@Override
	public BaseResult<TenantEmployeeDto> save(TenantEmployeeDto object) throws BasException {
		tenantDao.deleteTenantEmployeeByMobilephone(object.getMobilephone());
		save(object, TenantEmployee.class, dao);
		return null;
	}

	@Override
	public BaseResult<TenantEmployeeDto> delete(String id) throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BaseResult<PageCriteria<TenantEmployeeDto>> query(QueryDTO query) throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public BaseResult<TenantEmployeeDto> get(String id) throws BasException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public TenantEmployeeDto getByMobilephone(String mobilephone) throws BasException {
		TenantEmployeeDto tenantEmployeeDto = null;
		List<TenantEmployee> tenantEmployeeList = tenantDao.getTenantEmployeeByMobilephone(mobilephone);
		if(tenantEmployeeList.size()>0){
			tenantEmployeeDto = new TenantEmployeeDto();
			try {
				super.commonBuild(tenantEmployeeDto, tenantEmployeeList.get(0));
			} catch (Exception e) {
				log.info(e.getMessage());
			}
		}
		return tenantEmployeeDto;
	}
	


}
