package com.ekingwin.bas.cloud.user.dto;

import com.ekingwin.bas.cloud.dto.BasePageDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Objects;
@ApiModel("外部用户信息")
@Data
public class IpcOutUserDto extends BasePageDto {

    @ApiModelProperty(value = "主键", required = false)
    private Long id;

    @ApiModelProperty(value = "联系人", required = false)
    private String contacts;//联系人

    @ApiModelProperty(value = "联系人拼音", hidden = true)
    private String contactspinyin;//联系人

    @ApiModelProperty(value = "联系方式", required = false)
    private String callPhone;//联系方式

    @ApiModelProperty(value = "邮箱", required = false)
    private String email;

    @ApiModelProperty(value = "状态", required = false)
    private int state;//状态（是否禁用）

    @ApiModelProperty(value = "公司名称", required = false)
    private String company;//公司名称

    @ApiModelProperty(value = "所属职位", required = false)
    private String jobTitle;//工作职位

    @ApiModelProperty(value = "企业类型", required = false)
    private String companyType;//公司类型

    @ApiModelProperty(value = "企业类型id", required = false)
    private String companyTypeId;//公司类型id

    @ApiModelProperty(value = "所属部门", required = false)
    private String department;//部门

    @ApiModelProperty(value = "所属城市", required = false)
    private String city;

    @ApiModelProperty(value = "密码", required = false)
    private String password; //密码

    @ApiModelProperty(value = "企业员工数", required = false)
    private Integer employeeNumber;//员工数

    @ApiModelProperty(value = "企业网站", required = false)
    private String companyWeb;//公司网站

    @ApiModelProperty(value = "社会信用代码", required = false)
    private String socialCreditCode;//社会信用代码

    @ApiModelProperty(value = "证件照", required = false)
    private String identificationPhoto;//证件照

    @ApiModelProperty(value = "用户名", required = false)
    private String name;//用户名

    @ApiModelProperty(value = "创建时间", required = false)
    private String newTime;//创建时间

    @ApiModelProperty(value = "更新时间", required = false)
    private String updateTime;//更新时间

    @ApiModelProperty(value = "用户信息", required = false)
    private String usermsg;//用户信息

    @ApiModelProperty(value = "创建者", required = false)
    private String newUser;//创建者

    @ApiModelProperty(value = "标识", required = false,hidden = true)
    private String mark;//标识


    public int getState() {
        return state;
    }

    public void setState(int state) {
        this.state = state;
    }

    @Override
    public String toString() {
        return "IpcOutUserDto{" +
                "id=" + id +
                ", contacts='" + contacts + '\'' +
                ", callPhone='" + callPhone + '\'' +
                ", email='" + email + '\'' +
                ", state=" + state +
                ", company='" + company + '\'' +
                ", jobTitle='" + jobTitle + '\'' +
                ", companyType='" + companyType + '\'' +
                ", department='" + department + '\'' +
                ", city='" + city + '\'' +
                ", password='" + password + '\'' +
                ", employeeNumber=" + employeeNumber +
                ", companyWeb='" + companyWeb + '\'' +
                ", socialCreditCode='" + socialCreditCode + '\'' +
                ", identificationPhoto='" + identificationPhoto + '\'' +
                ", name='" + name + '\'' +
                ", newTime='" + newTime + '\'' +
                ", updateTime='" + updateTime + '\'' +
                ", usermsg='" + usermsg + '\'' +
                ", newUser='" + newUser + '\'' +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof IpcOutUserDto)) return false;
        IpcOutUserDto that = (IpcOutUserDto) o;
        return state == that.state &&
                Objects.equals(id, that.id) &&
                Objects.equals(contacts, that.contacts) &&
                Objects.equals(callPhone, that.callPhone) &&
                Objects.equals(email, that.email) &&
                Objects.equals(company, that.company) &&
                Objects.equals(jobTitle, that.jobTitle) &&
                Objects.equals(companyType, that.companyType) &&
                Objects.equals(department, that.department) &&
                Objects.equals(city, that.city) &&
                Objects.equals(password, that.password) &&
                Objects.equals(employeeNumber, that.employeeNumber) &&
                Objects.equals(companyWeb, that.companyWeb) &&
                Objects.equals(socialCreditCode, that.socialCreditCode) &&
                Objects.equals(identificationPhoto, that.identificationPhoto) &&
                Objects.equals(name, that.name) &&
                Objects.equals(newTime, that.newTime) &&
                Objects.equals(updateTime, that.updateTime) &&
                Objects.equals(usermsg, that.usermsg) &&
                Objects.equals(newUser, that.newUser);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, callPhone, email, state, company, jobTitle, companyType, department, city, password, employeeNumber, companyWeb, socialCreditCode, identificationPhoto, name, newTime, updateTime, usermsg, newUser);
    }

}
